@ECHO OFF
REM BC+FW Stress Test

REM ***************************** Config *****************************
Set BC_FILE_PATH= IAP\BootCodeUpdater.ekt
Set FW_FILE_PATH= IAP\FW.ekt
Set Update_BC_Time= 15
REM WIN8_BRIDGE: 0:Elan bridge(0xb) \ 1:Win 8 or No Bridge 
Set WIN8_BRIDGE= 1
REM VDD(Only use with Elan Bridge): 0:5.0V \ 1:3.3V(default) \ 2:3.0V \ 3:2.8V \ Other
Set VDD= 1
REM VIO(Only use with Elan Bridge): 0:5.0V \ 1:3.3V(default) \ 2:3.0V \ 3:2.8V \ 4:1.8 \ Other
Set VIO= 1
REM I2C_Addr(Only use with Elan Bridge): 0x0 means set to default value 0x20.
Set I2C_Addr= 0x0
REM INTERFACE: 
REM USB or FastUSB:1 \ I2C or FastI2C:2 \SPI:3~6 \Hid over I2C: 8
REM 3: SPI SL(TP is MA Hi Rising Edge Out)
REM 4: SPI SL(TP is MA Hi Falling Edge Out)
REM 5: SPI MA(TP is SL Hi Rising Edge Out)
REM 6: SPI MA(TP is SL Hi Falling Edge Out)
Set INTERFACE= 1
REM NEW_IAP: Only used in I2C\Hid over I2C interface
Set NEW_IAP= 1
REM Master/Slave1/Slave2 Addr=0x20/0x40/0x42, Set 0x0 means not to update.
REM Only need to set MASTER_ADDR: 3900, Hid over I2C, and 3300 Lobyte(BootCodeVer)>=0x8A
Set MASTER_ADDR= 0x20
Set SLAVE1_ADDR= 0x40
Set SLAVE2_ADDR= 0x0
REM REK_DELAY_TIME(seconds): 0:No ReK \ >0:ReK after IAP
Set REK_DELAY_TIME= 3
REM STOP_TEST_FAILED_TIMES: Retry times while IAP failed.
Set STOP_TEST_FAILED_TIMES= 10
REM WAITING_TIME_FOR_RETRY: Retry delay time (sec).
Set WAITING_TIME_FOR_RETRY= 3
REM ***************************** Config *****************************
Set PID= 0x0














title Elan IAP tool
rd /s /q Log
mkdir Log
IF %WIN8_BRIDGE% EQU 0 Set PARAM_BRIDGE_TYPE="-E"
IF %NEW_IAP% EQU 1 Set PARAM_NEW_IAP="-n"
set i=0
set f=0
set s=0
:LOOP
cls
set /a i=%i%+1
echo **************************** %i%-th IAP ***************************
echo **************************** %i%-th IAP *************************** >> Log\Final_Result.txt
echo Start Boot Code update Procedure
echo Start Boot Code update Procedure >> Log\Final_Result.txt
IAP.exe -r "%STOP_TEST_FAILED_TIMES%,%WAITING_TIME_FOR_RETRY%" %PARAM_BRIDGE_TYPE%  -d %VDD% -o %VIO% -a %I2C_Addr% -p %PID% -i %INTERFACE% -0 %MASTER_ADDR% -1 %SLAVE1_ADDR% -2 %SLAVE2_ADDR%  -f %BC_FILE_PATH% -c %PARAM_NEW_IAP% -b
IF %ERRORLEVEL% EQU 1 GOTO BCDONE
GOTO FAILED

:BCDONE
set /a s=%s%+1
echo Download Boot code Success (Success= %s%, Failed= %f%)
echo Download Boot code Success (Success= %s%, Failed= %f%) >> Log\Final_Result.txt
echo Wait %Update_BC_Time%s for Boot Code Update
IAP.exe -r "%STOP_TEST_FAILED_TIMES%,%WAITING_TIME_FOR_RETRY%" -s %Update_BC_Time%
echo ---
echo Start FW update Procedure
echo Start FW update Procedure >> Log\Final_Result.txt
IF %INTERFACE% EQU 1 GOTO USB
IAP.exe -r "%STOP_TEST_FAILED_TIMES%,%WAITING_TIME_FOR_RETRY%" %PARAM_BRIDGE_TYPE%  -d %VDD% -o %VIO% -a %I2C_Addr% -p %PID% -i %INTERFACE% -0 %MASTER_ADDR% -1 %SLAVE1_ADDR% -2 %SLAVE2_ADDR%  -f %FW_FILE_PATH% -c %PARAM_NEW_IAP%
GOTO RESULT
:USB
IAP.exe -r "%STOP_TEST_FAILED_TIMES%,%WAITING_TIME_FOR_RETRY%" %PARAM_BRIDGE_TYPE%  -d %VDD% -o %VIO% -a %I2C_Addr% -p 0x0b -i %INTERFACE% -0 %MASTER_ADDR% -1 %SLAVE1_ADDR% -2 %SLAVE2_ADDR%  -f %FW_FILE_PATH% -c %PARAM_NEW_IAP%

:RESULT
IF %ERRORLEVEL% EQU 1 GOTO FWDONE
GOTO FAILED

:FWDONE
set /a s=%s%+1
echo Update FW Success (Success= %s%, Failed= %f%)
echo Update FW Success (Success= %s%, Failed= %f%) >> Log\Final_Result.txt
IF %REK_DELAY_TIME% GTR 0 Goto REK
IAP.exe -s %WAITING_TIME_FOR_RETRY%
GOTO LOOP

:FAILED
set /a f=%f%+1
echo FAILED (Success= %s%, Failed= %f%) (err= %ERRORLEVEL%)
echo FAILED (Success= %s%, Failed= %f%) (err= %ERRORLEVEL%) >> Log\Final_Result.txt
mkdir Log%f%
XCOPY /H /Q /Y Log\*.* Log%f%\*.*
echo %STOP_TEST_FAILED_TIMES%  >> Log\Final_Result.txt
IF %f% GTR %STOP_TEST_FAILED_TIMES% GOTO END
IAP.exe -s %WAITING_TIME_FOR_RETRY%
GOTO LOOP

:ReK
echo Delay %REK_DELAY_TIME%s for ReK...
IAP.exe -r "%STOP_TEST_FAILED_TIMES%,%WAITING_TIME_FOR_RETRY%" -s %REK_DELAY_TIME%
echo ********************* Write Flash Key and ReK *********************
echo ********************* Write Flash Key and ReK ********************* >> Log\Final_Result.txt
IAP.exe -r "%STOP_TEST_FAILED_TIMES%,%WAITING_TIME_FOR_RETRY%" -K %PARAM_BRIDGE_TYPE% -d %VDD% -o %VIO% -a %I2C_Addr% -p %PID% -i %INTERFACE% -c
IF %ERRORLEVEL% EQU 1 GOTO REK_DONE

:REK_FAILED
echo FAILED (err= %ERRORLEVEL%)
echo FAILED (err= %ERRORLEVEL%) >> Log\Final_Result.txt
IAP.exe -s %WAITING_TIME_FOR_RETRY%
GOTO LOOP

:REK_DONE
echo SUCCESS
echo SUCCESS >> Log\Final_Result.txt
IAP.exe -s %WAITING_TIME_FOR_RETRY%
GOTO LOOP

:END
pause
