@ECHO OFF
REM ReK Stress Test
REM ***************************** Config *****************************
REM WIN8_BRIDGE: 0:Elan bridge(0xb) \ 1:Win 8 or No Bridge
Set WIN8_BRIDGE= 1
REM VDD(Only use with Elan Bridge): 0:5.0V \ 1:3.3V(default) \ 2:3.0V \ 3:2.8V \ Other
Set VDD= 1
REM VIO(Only use with Elan Bridge): 0:5.0V \ 1:3.3V(default) \ 2:3.0V \ 3:2.8V \ 4:1.8 \ Other
Set VIO= 4
REM I2C_Addr(Only use with Elan Bridge): 0x0 means set to default value 0x20.
Set I2C_Addr= 0x0
REM INTERFACE: 
REM USB or FastUSB:1 \ I2C or FastI2C:2 \SPI:3~6 \Hid over I2C: 8
REM 3: SPI SL(TP is MA Hi Rising Edge Out)
REM 4: SPI SL(TP is MA Hi Falling Edge Out)
REM 5: SPI MA(TP is SL Hi Rising Edge Out)
REM 6: SPI MA(TP is SL Hi Falling Edge Out)
Set INTERFACE= 1
REM ***************************** Config *****************************
Set PID= 0x0

title Elan ReK tool
set i=0
set f=0
set s=0
:LOOP
cls
echo %~n0
set /a i=%i%+1
echo ********************* %i%-th ReK *********************
echo ********************* %i%-th ReK ********************* >> Log\Final_Result.txt
IAP.exe -K %PARAM_BRIDGE_TYPE% -d %VDD% -o %VIO% -a %I2C_Addr% -p %PID% -c -i %INTERFACE%
IF %ERRORLEVEL% EQU 1 GOTO REK_DONE

:REK_FAILED
set /a f=%f%+1
echo FAILED (err= %ERRORLEVEL%) (Success=%s%, Failed=%f%)
echo FAILED (err= %ERRORLEVEL%) (Success=%s%, Failed=%f%)>> Log\Final_Result.txt
GOTO END

:REK_DONE
set /a s=%s%+1
echo SUCCESS (Success=%s%, Failed=%f%)
echo SUCCESS (Success=%s%, Failed=%f%)>> Log\Final_Result.txt
GOTO END

:END
IAP.exe -s 1
goto LOOP
pause