@ECHO OFF
REM Update FW

REM ***************************** Config *****************************
REM BC_FILE_PATH: BC File Path
REM Set BC_FILE_PATH=
REM FW_FILE_PATH: FW File Path
REM Set FW_FILE_PATH= IAP\FW.ekt
REM Set FW_FILE_PATH= IAP\MASTER_FW.ekt;IAP\SLAVE1_FW.ekt
Set FW_FILE_PATH= IAP\UX461.ekt
Set Update_BC_Time= 10
REM WIN8_BRIDGE: 0:Elan bridge(0xb) \ 1:Win 8 or No Bridge 
Set WIN8_BRIDGE= 1
REM VDD(Only use with Elan Bridge): 0:5.0V \ 1:3.3V(default) \ 2:3.0V \ 3:2.8V \ Other
Set VDD= 1
REM VIO(Only use with Elan Bridge): 0:5.0V \ 1:3.3V(default) \ 2:3.0V \ 3:2.8V \ 4:1.8 \ Other
Set VIO= 1
REM I2C_Addr(Only use with Elan Bridge): 0x0 means set to default value 0x20.
Set I2C_Addr= 0x0
REM INTERFACE: 
REM USB or FastUSB:1 \ I2C or FastI2C:2 \SPI:3~6 \Hid over I2C: 8 \SPI for iTouch: 9
REM 3: SPI SL(TP is MA Hi Rising Edge Out)
REM 4: SPI SL(TP is MA Hi Falling Edge Out)
REM 5: SPI MA(TP is SL Hi Rising Edge Out)
REM 6: SPI MA(TP is SL Hi Falling Edge Out)
Set INTERFACE= 8
REM NEW_IAP: Only used in I2C interface
Set NEW_IAP= 1
REM Master/Slave1/Slave2 Addr=0x20/0x40/0x42, Set 0x0 means not to update.
REM Only need to set MASTER_ADDR: 3900, Hid over I2C, and 3300 Lobyte(BootCodeVer)>=0x8A
REM Set SLAVE1_ADDR=0x40 if solution is 3915M I2C
Set MASTER_ADDR= 0x20
Set SLAVE1_ADDR= 0x0
Set SLAVE2_ADDR= 0x0
REM REK_DELAY_TIME(seconds): 0:No ReK \ >0:ReK after IAP
Set REK_DELAY_TIME= 3
REM STOP_TEST_FAILED_TIMES: Retry times while IAP or ReK failed.
REM It will not create log into NG folder, if retry success.
Set STOP_TEST_FAILED_TIMES= 0
REM WAITING_TIME_FOR_RETRY: Retry delay time (sec).
Set WAITING_TIME_FOR_RETRY= 2
REM REK_TIMEOUT(seconds)
Set REK_TIMEOUT= 10
REM OUT_RETURNCODE: output return code if external program need = 1, else set to 0
Set OUT_RETURNCODE= 0
REM IF distinguish device for multi-devices, can set Device ID Code to assign device
Set DEVICE_IDCODE=""
REM ***************************** Config *****************************
Set PID= 0x00
Set VID= 0x04f3
Set PortNo=""
title Elan IAP tool
IF %WIN8_BRIDGE% EQU 0 Set PARAM_BRIDGE_TYPE="-E"
IF %NEW_IAP% EQU 1 Set PARAM_NEW_IAP="-n"
set i=0
set f=0
set s=0
:LOOP
cls
cd %~dp0
set /a i=%i%+1
echo **************************** %i%-th IAP ***************************
echo **************************** %i%-th IAP *************************** >> AP\Log\Final_Result.txt
echo Start FW update Procedure
echo Start FW update Procedure >> AP\Log\Final_Result.txt

REM Check PID
IF %INTERFACE% EQU 1 GOTO CHECK_PID_LOCK
GOTO CHECK_PID_DONE

:CHECK_PID_LOCK
AP\IAP.exe -C -r "0,0" %PARAM_BRIDGE_TYPE% -d %VDD% -o %VIO% -a %I2C_Addr% -p %PID% -V %VID% -i %INTERFACE% -f %FW_FILE_PATH% -c -P %PortNo% -I %DEVICE_IDCODE%
IF %ERRORLEVEL% EQU 1 GOTO CHECK_PID_DONE

echo FAILED (err= %ERRORLEVEL%)
echo FAILED (err= %ERRORLEVEL%) >> AP\Log\Final_Result.txt
GOTO CHECK_PID_FAIL

:CHECK_PID_DONE
IF %INTERFACE% EQU 2 GOTO USB
AP\IAP.exe %PARAM_BRIDGE_TYPE% -d %VDD% -o %VIO% -a %I2C_Addr% -p %PID% -i %INTERFACE% -0 %MASTER_ADDR% -1 %SLAVE1_ADDR% -2 %SLAVE2_ADDR%  -f %FW_FILE_PATH% -c %PARAM_NEW_IAP% -I %DEVICE_IDCODE%

GOTO RESULT
:USB
AP\IAP.exe %PARAM_BRIDGE_TYPE% -d %VDD% -o %VIO% -a %I2C_Addr% -p 0x0b -i %INTERFACE% -0 %MASTER_ADDR% -1 %SLAVE1_ADDR% -2 %SLAVE2_ADDR%  -f %FW_FILE_PATH% -c %PARAM_NEW_IAP% -I %DEVICE_IDCODE%

:RESULT
IF %ERRORLEVEL% EQU 1 GOTO FWDONE
GOTO FAILED

:FWDONE
set /a s=%s%+1
echo Update FW Success (Success= %s%, Failed= %f%)
echo Update FW Success (Success= %s%, Failed= %f%) >> AP\Log\Final_Result.txt
IF %REK_DELAY_TIME% GTR 0 Goto REK
GOTO END

:FAILED
set /a f=%f%+1
echo FAILED (Success= %s%, Failed= %f%) (err= %ERRORLEVEL%)
echo FAILED (Success= %s%, Failed= %f%) (err= %ERRORLEVEL%) >> AP\Log\Final_Result.txt
REM mkdir Log%f%
REM XCOPY /H /Q /Y Log\*.* Log%f%\*.*
echo %STOP_TEST_FAILED_TIMES%  >> AP\Log\Final_Result.txt
IF %f% GTR %STOP_TEST_FAILED_TIMES% GOTO END
echo Wait %WAITING_TIME_FOR_RETRY%s for retry
ping 123.45.67.89 -n %WAITING_TIME_FOR_RETRY% -w 1000 > nul
GOTO LOOP

:ReK
echo Delay %REK_DELAY_TIME%s for ReK...
ping 123.45.67.89 -n %REK_DELAY_TIME% -w 1000 > nul
echo ********************* Write Flash Key and ReK *********************
echo ********************* Write Flash Key and ReK ********************* >> AP\Log\Final_Result.txt
AP\IAP.exe -K %PARAM_BRIDGE_TYPE% -d %VDD% -o %VIO% -a %I2C_Addr% -p %PID% -i %INTERFACE% -c -S %REK_TIMEOUT% -I %DEVICE_IDCODE%
IF %ERRORLEVEL% EQU 1 GOTO REK_DONE

:REK_FAILED
echo FAILED (err= %ERRORLEVEL%)
echo FAILED (err= %ERRORLEVEL%) >> AP\Log\Final_Result.txt
GOTO END

:REK_DONE
echo SUCCESS
echo SUCCESS >> AP\Log\Final_Result.txt
GOTO END

:CHECK_PID_FAIL
REM color c0
echo The IAP Tool is not using in current project. Please use the correct tool.
GOTO END

REM :END
REM EXIT /B %ERRORLEVEL%
REM pause

:RETURN_CODE
EXIT /B %ERRORLEVEL%

:END
IF %OUT_RETURNCODE% EQU 1 GOTO RETURN_CODE
pause
